
import client
import interface
import pygame
from pygame.locals import *
import server_stub
import menu
import battle
import pc_canvas
import sound
from sound import sounds

pc_canvas.load_tiles()

battle_delay = 750 #ms

class PlayerInterface(interface.Interface):

    def __init__(self,position):
        interface.Interface.__init__(self)
        self.canvas = pc_canvas.Canvas(position)

        # create side bar panel
        sp = pc_canvas.sidePanel(client.panelsize,client.screenheight)

        self.sp = sp

    def draw_item(self, item):
        items = pygame.Surface((20,20))
        # XXX if the item is carried, then the icon isn't in icons, so do something else
        try:
            icon = pygame.transform.scale((pc_canvas.icons[item.id].images["standing"]).convert(),(20,20))
            items.blit(icon,(0,0,20,20))
        except:
            print client.things[client.pid].bag
            print "COULD NOT FIND ICON"
        return items

    def draw_items_carried(self, player):
       items = pygame.Surface((170,50))
       items.fill(self.sp.get_background())
       # XXX maybe could have the if not line be in the for loop
       if not player.items_in_bag() == []:
           counter = 0
           for item in player.items_in_bag():
               items.blit(self.draw_item(item),(counter,0))
               counter += 22 
       return items       
    
    def update_everything(self):
        self.sp.map.update()
        self.sp.lifebar.update()
        self.sp.magicbar.update()
        self.sp.crystalbar.update()
        #self.sp.sprites.add('middle1',
                              # self.draw_life(client.things[client.pid]))
        #self.sp.replace_region('bottom', self.sp.map.surface)
        #import random
        #if menu.active_menu:
        #    self.sp.add_panel('middle3',menu.active_menu.subpanel)
        #else:
        #    self.sp.remove_panel(menu.active_menu.subpanel)
        #self.sp.replace_region('middle2',
        #                       self.draw_items_carried(client.things[client.pid]))
        self.canvas.moveto(*client.things[client.pid].position)

    def draw_everything(self):
        self.canvas.draw(client.screen)
        self.sp.draw(client.screen)
        interface.Interface.draw_everything(self)

    def handle_keys_pressed(self,keys_down):
        command = {'move_x': 0,
                   'move_y': 0,
                   }
        # XXX All movement logic against current game state goes in here.
        if keys_down[K_LEFT]: command['move_x'] = -1
        elif keys_down[K_RIGHT]: command['move_x'] = 1
        if keys_down[K_UP]: command['move_y'] = -1
        elif keys_down[K_DOWN]: command['move_y'] = 1
        return command

    def command_ok(self,command):
        return not self.canvas.player1.moving

    def update_game_state(self,command):
        if command and not client.things[client.pid].isDead():
            if command in ('fight', 'heal', 'fire'):
                self.battle_countdown = battle_delay
                menu.active_menu.deactivate()
                if command == 'fight':
                    damages = server_stub.fight(client.pid)
                    if sound.on:
                        sounds["swords"].play()
                elif command == 'heal':
                    damages = []
                    server_stub.heal(client.pid)
                    if sound.on:
                        sounds["aura"].play()
                elif command == 'fire':
                    damages = server_stub.fire(client.pid)
                    if sound.on:
                        sounds["chestsmash"].play()
                for cid, damage in damages:
                    pc_canvas.icons[cid].show_damage(damage,start=True)
            elif command == 'spell':
                server_stub.fight(client.pid)
            else:
                x = command['move_x']
                y = command['move_y']
                if x or y:
                    server_stub.move(client.pid, x, y)

        interface.Interface.update_game_state(self,command)
        
        if not client.things[client.pid].isDead():
            player = client.things[client.pid]
            player.check_engagement()
            if player.engaged() and self.battle_countdown <= 0:
                if not menu.active_menu:
                    battle.main_menu.activate(self.sp)
            elif menu.active_menu:
                menu.active_menu.deactivate()
